<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../../bower_components/paper-input/paper-input.html">


<dom-module id="mi-propiedades">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <h2>Hello [[prop1]]!</h2>
    <h3>Data binding</h3>
    <a href="[[url]]">[[url]]</a>
    <paper-input label="Escribe algo" value="{{url}}"></paper-input>
    <button on-click="cambiarValor">Cambia valor</button>
    <h3>Observers</h3>
    <p>[[valoracion]]</p>
    <h3>Computed properties</h3>
    <fieldset>
      <label>Primer numero: [[param1]]</label><br>
      <label>Segundo numero: [[param2]]</label><br>
      <p><strong>La suma es: </strong>[[totalCalculo]]</p>
    </fieldset>
  </template>

  <script>
    /**
     * `mi-propiedades`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class MiPropiedades extends Polymer.Element {
      static get is() { return 'mi-propiedades'; }
      static get properties() {
        return {
          prop1: {
            type: String,
            value: 'mi-propiedades'
          },
          url: {
            type: String,
            value: 'www.google.com'
          },
          valoracion: {
            type: String,
            notify: true,
            observer: '_valoracionObserver'
          },
          param1: Number,
          param2: Number,
          totalCalculo: {
            type: Number,
            value: 0,
            readOnly: true,
            notify: true,
            computed: 'sumaTotalesTransacion(param1,param2)'
          }
        };
      }
      _valoracionObserver(newValue, oldValue) {
        if (newValue === undefined ) {
          console.log(" if es igual a true !! ");
          console.log("eñ nuevo valor es: " + newValue);
        } else {
          console.log("oldValue: ", oldValue);
        }
      }
      cambiarValor(){
        this.valoracion = Date.now();
      }
      sumaTotalesTransacion(pm1, pm2) {
        return pm1+pm2;
      }
    }

    window.customElements.define(MiPropiedades.is, MiPropiedades);
  </script>
</dom-module>
